<template>
    <div>
        <v-row>
            <v-col>
                <data-table
                    v-model="items"
                    endpoint="api/products/all"
                    :title="$t('product')"
                    :filters="filters"
                    :headers="headers"
                    :search-label="searchLabel"
                >
                    <template v-slot:filters="{ filters , confirmed }">
                        <product-filters
                            :brands.sync="filters.brand"
                            :business_types.sync="filters.business_type"
                            :types.sync="filters.type"
                            :genders.sync="filters.gender"
                            :prices.sync="filters.price"
                            :new-arrival.sync="filters.new_arrival"
                            :most-popular.sync="filters.most_popular"
                            :status.sync="filters.status"
                            :variants.sync="filters.variants"
                            :categories.sync="filters.categories"
                            @confirmed="confirmed"
                        ></product-filters>
                    </template>

                    <template v-slot:buttons>
                        <v-btn
                            color="primary"
                            to="/product/create"
                        >
                            <v-icon class="medium" color="white" left>mdi-plus</v-icon>
                            {{ $t('product') }}
                        </v-btn>
                    </template>

                    <template v-slot:item="{ item, index }">
                        <tr>
                            <td>{{ item.name }}</td>
                            <td>{{ item.type.name }}</td>
                            <td>{{ item.brand.name }}</td>
                            <td>{{ item.gender.name }}</td>
                            <td class="text-right">{{ pricing(item.pricing).price | currency }} MYR</td>
                            <td>{{ item.sku }}</td>
                            <td>{{ item.business_type.name }}</td>
                            <td>
                                <v-chip
                                    :color="item.enabled ? 'success' : 'error'"
                                    text-color="white"
                                    label
                                >
                                    {{ item.enabled ? $t('enabled') : $t('disabled') }}
                                </v-chip>
                            </td>
                            <td>
                                 <v-menu
                                    :close-on-content-click="false"
                                    offset-y
                                    bottom
                                >
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-btn
                                            color="primary"
                                            dark
                                            icon
                                            v-bind="attrs"
                                            v-on="on"
                                        >
                                            <v-icon>mdi-dots-horizontal</v-icon>
                                        </v-btn>
                                    </template>

                                    <v-list dense>
                                        <v-list-item>
                                            <v-btn
                                                @click="edit(item)"
                                                class="text-capitalize"
                                                color="primary"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-pencil</v-icon>
                                                {{ $t('edit') }}
                                            </v-btn>
                                        </v-list-item>
                                        <v-divider class="my-2"></v-divider>
                                        <v-list-item>
                                            <v-btn
                                                :to="`/product/stock/${item.id}`"
                                                class="text-capitalize"
                                                color="primary"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-pencil</v-icon>
                                                {{ $tc('stock', 2) }}
                                            </v-btn>
                                        </v-list-item>
                                        <v-divider class="my-2"></v-divider>
                                        <v-list-item>
                                            <v-btn
                                                @click="openDeleteDialog(item)"
                                                class="text-capitalize"
                                                color="error"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-delete</v-icon>
                                                {{ $t('delete') }}
                                            </v-btn>
                                        </v-list-item>
                                    </v-list>
                                </v-menu>
                            </td>
                        </tr>
                    </template>
                </data-table>
            </v-col>
        </v-row>

        <v-dialog
            v-model="dialog"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('delete_', [$t('product')]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('del_desc_1') }}</p>
                    <p>{{ $t('del_desc_2') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="closeDeleteDialog"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="remove"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </div>
</template>

<script>
    import DataTable from "../DataTable";
    import VStockStatusSelect from "../VStockStatusSelect";
    import util from "../../../mixins/util"
    import ProductFilters from "../filters/ProductFilters";
    import { mapMutations } from "vuex";

    export default {
        name: "Product",
        components: {VStockStatusSelect, DataTable, ProductFilters},
        mixins: [ util ],
        data: () => ({
            filters: {
                brand: [],
                business_type: [],
                type: [],
                gender: [],
                price: [],
                variants: [],
                categories: [],
                most_popular: undefined,
                new_arrival: undefined,
                status: undefined
            },
            items: [],
            deleting: null,
            loading: false,
            dialog: false
        }),

        computed: {
            headers() {
                return [
                    { text: this.$t('name'), value: 'name', sortable: false },
                    { text: this.$tc('collection', 1), value: 'type', sortable: false },
                    { text: this.$tc('brand', 1), value: 'brand', sortable: false },
                    { text: this.$tc('gender', 1), value: 'gender', sortable: false },
                    { text: this.$t('price'), value: 'price', align: 'right' },
                    { text: this.$t('sku'), value: 'sku', sortable: false },
                    { text: this.$t('business_type'), value: 'business_type', sortable: false },
                    { text: this.$t('status'), value: 'status', sortable: false },
                    { text: this.$t('action'), value: 'actions', sortable: false },
                ]
            },

            searchLabel() {
                return this.$t('search_using', {
                    field: this.$t('name') + this.$t('or', {field: this.$tc('brand', 1)})
                });
            },

            statuses() {
                return [
                    { text: this.$t('enabled'), value: 1 },
                    { text: this.$t('disabled'), value: 0 }
                ];
            }
        },

        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),
            edit(item) {
                this.$router.push({
                    name: 'productEdit',
                    params: {
                        id: item.id
                    }
                })
            },

            openDeleteDialog(item) {
                this.deleting = item;
                this.dialog = true;
            },

            closeDeleteDialog() {
                this.deleting = null;
                this.dialog = false;
            },

            remove() {
                this.loading = true;
                axios.delete('api/products/' + this.deleting.id)
                    .then(({ data }) => {
                        if(data.result === true) {
                            const index = this.items.findIndex(item => item.id === this.deleting.id);
                            this.items.splice(index, 1);
                            this.success(this.$t('product_action.deleted'));
                            this.closeDeleteDialog();
                        }
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    });
            }
        }
    }
</script>

<style scoped>
</style>
